/**
 * 
 */
package com.unitesk.requality.eclipse.tools;

import java.util.Comparator;

import org.eclipse.core.resources.IProject;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

public class TreeDBNodeComparator implements Comparator<Object> {
    @Override
    public int compare(Object o1, Object o2) {

        if (o1 instanceof TreeNode && o2 instanceof TreeNode) {
            TreeNode n1 = (TreeNode) o1;
            TreeNode n2 = (TreeNode) o2;
            if (n1.getUUId().equals(n2.getUUId()))
                return 0;
            return n1.getQualifiedId().compareTo(n2.getQualifiedId());
        }
        if (o1 instanceof TreeDB && o2 instanceof TreeDB) {
            TreeDB db1 = (TreeDB) o1;
            TreeDB db2 = (TreeDB) o2;
            if (db1.equals(db2))
                return 0;
            IProject prj1 = TreesTracker.getTracker().getProject(db1);
            IProject prj2 = TreesTracker.getTracker().getProject(db2);
            return prj1.getName().compareTo(prj2.getName());
        }
        return 0;
    }
}