package com.unitesk.requality.merge;

import java.util.ArrayList;
import java.util.List;

public class NodeFilter {

    private Node refNode;
    private boolean sameType;
    private boolean equal;
    private boolean sameParent;
    private boolean sameText;

    public NodeFilter(Node refNode, boolean sameNodeType, boolean mustBeEqual,
	    boolean sameParent, boolean containsSameText) {
	this.refNode = refNode;
	this.sameType = sameNodeType;
	this.equal = mustBeEqual;
	this.sameParent = sameParent;
	this.sameText = containsSameText;
    }

    public List<Node> filter(List<Node> list) {
	List<Node> filteredList = new ArrayList<Node>();
	for (Node current : list) {
	    if (sameType
		    && current.getDomNode().getNodeType() != refNode
			    .getDomNode().getNodeType())
		continue;
	    if (equal && !current.isEqual(refNode))
		continue;
	    if (sameParent && current.getParent() != null
		    && refNode.getParent() != null
		    && !current.getParent().isEqual(refNode.getParent()))
		continue;
	    if (sameText
		    && !current.getDomNode().getNodeValue()
			    .contains(refNode.getDomNode().getNodeValue()))
		continue;
	    filteredList.add(current);
	}
	return filteredList;
    }
}
