package com.unitesk.requality.tests.core;

import static org.junit.Assert.fail;

import java.io.File;
import java.io.IOException;

import org.junit.Before;
import org.junit.Test;

import com.unitesk.requality.core.FSStorage;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.documents.DocumentImporter;
import com.unitesk.requality.nodetypes.Document;
import com.unitesk.requality.nodetypes.Requirement;
import com.unitesk.requality.tests.utils.Ulils;

public class DocumentImport {
    private Document docRoot;
    private Document docImgs;

    @Before
    public void setUp() throws Exception {
        String path = System.getProperty("java.io.tmpdir") + File.separator
                + "treedb.test";
        if (new File(path).exists()) {
            Ulils.recursiveDelete(new File(path));
        }
        TreeDB db = new TreeDB(new FSStorage(path));
        db.addNodeType("Document", Document.class);
        docRoot = (Document) db.getRootNode().createChild("Documents", "Document");
        new File(docRoot.getHTMLPath()).getParentFile().mkdirs();
        DocumentImporter din = new DocumentImporter();
        File imgHtml = new File("test-data/html/image.html");
        docImgs = (Document) docRoot.createChild(imgHtml.getName());
        String docId = docImgs.getQualifiedId();
        din.importDocument(docId, imgHtml, new File(docImgs.getHTMLPath()), db, (Requirement) db.getNode(Requirement.getTypeRootQId()),"UTF-8");
    }

    @Test
    public void importImageCount() throws IOException {
        fail();
    }

    @Test
    public void importImageObject() {
        fail();
    }

    @Test
    public void importImageObjectInline() {
        fail();
    }

    @Test
    public void importCSS() {
        fail();
    }

    @Test
    public void importDeepCSS() {
        fail();
    }
}
