package com.unitesk.requality.tests.core;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import com.unitesk.requality.core.MemoryStorage;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.TreeStorage;

public class IdQueryTest {
    private TreeDB db;
    
    @Before
    public void init() {
        TreeStorage storage = new MemoryStorage();
        db = new TreeDB(storage);
    }

    // TODO: test for default node type 
    
    @Test
    public void fullIdOperations() {
        TreeNode root=db.getRootNode();
        TreeNode a= root.createChild("a");
        TreeNode aa= a.createChild("aa");
        TreeNode ab= a.createChild("ab");
        TreeNode b= root.createChild("b");
        TreeNode ba= b.createChild("ba");
        TreeNode bb= b.createChild("bb");

        assertEquals("/", root.getQualifiedId());
        assertEquals("/a", a.getQualifiedId());
        assertEquals("/a/aa", aa.getQualifiedId());
        assertEquals("/a/ab", ab.getQualifiedId());
        assertEquals("/b", b.getQualifiedId());
        assertEquals("/b/ba", ba.getQualifiedId());
        assertEquals("/b/bb", bb.getQualifiedId());

        String rootQId=root.getQualifiedId();
        String aQId=a.getQualifiedId();
        String aaQId=aa.getQualifiedId();
        String abQId=ab.getQualifiedId();
        String bQId=b.getQualifiedId();
        String baQId=ba.getQualifiedId();
        String bbQId=bb.getQualifiedId();

        assertEquals(root.getUUId(), db.getNode(rootQId).getUUId());
        assertEquals(a.getUUId(), db.getNode(aQId).getUUId());
        assertEquals(aa.getUUId(), db.getNode(aaQId).getUUId());
        assertEquals(ab.getUUId(), db.getNode(abQId).getUUId());
        assertEquals(b.getUUId(), db.getNode(bQId).getUUId());
        assertEquals(ba.getUUId(), db.getNode(baQId).getUUId());
        assertEquals(bb.getUUId(), db.getNode(bbQId).getUUId());
    }
}
