//package com.unitesk.requality.tests.depricated;
//
//import static org.junit.Assert.assertEquals;
//import static org.junit.Assert.assertNotNull;
//import static org.junit.Assert.assertNull;
//import static org.junit.Assert.assertTrue;
//import static org.junit.Assert.fail;
//
//import java.io.File;
//
//import org.junit.Before;
//import org.junit.Test;
//
//import com.unitesk.requality.core.TreeDB;
//import com.unitesk.requality.core.TreeDBIO;
//import com.unitesk.requality.core.TreeDBNode;
//import com.unitesk.requality.tests.nodetypes.AnotherTestNode;
//import com.unitesk.requality.tests.nodetypes.TestNode;
//
//public class CRUDTest {
//
//    protected String path = System.getProperty("java.io.tmpdir")
//            + File.separator + "treedb.test";
//    protected TreeDB db;
//
//    @Before
//    public void setUp() {
//        if (new File(path).exists()) {
//            TreeDBTest.recursiveDelete(new File(path));
//        }
//        db = new TreeDBIO(path);
//    }
//
//    @Test
//    public void createRoot() {
//        TestNode root = (TestNode) db.createRootNode(TestNode.type);
//
//        TestNode root2 = (TestNode) db.createRootNode(TestNode.type);
//
//        assertEquals(
//                "Second requiest for type root must return same node uuid",
//                root.getUUId(), root2.getUUId());
//
//        assertEquals("Second requiest for type root must return same node id",
//                root.getId(), root2.getId());
//
//        assertEquals(root.sizeChildren(), root2.sizeChildren());
//
//        String nodePath = db.getPath() + File.separator
//                + TestNode.type.getName() + File.separator
//                + TestNode.type.getFileName();
//
//        assertTrue(new File(nodePath).exists());
//    }
//
//    @Test
//    public void loadChildren() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node0 = db.createNode(root, "node0");
//        TreeDBNode node1 = db.createNode(root, "node1");
//        TreeDBNode node11 = db.createNode(node1, "node11");
//
//        db.saveAll();
//        db.clear();
//
//        TreeDBNode loadedRoot = db.createRootNode(TestNode.type);
//        assertEquals(root.getUUId(), loadedRoot.getUUId());
//        assertEquals(2, loadedRoot.sizeChildren());
//        TreeDBNode loadedNode0 = loadedRoot.findChild(node0.getId());
//        TreeDBNode loadedNode1 = loadedRoot.findChild(node1.getId());
//        TreeDBNode loadedNode11 = loadedNode1.findChild(node11.getId());
//        assertNotNull(loadedNode0);
//        assertEquals(node0.getId(), loadedNode0.getId());
//        assertEquals(0, loadedNode0.sizeChildren());
//        assertEquals(1, loadedNode1.sizeChildren());
//        assertEquals(0, loadedNode11.sizeChildren());
//        assertNotNull(loadedNode11);
//        assertEquals(node11.getId(), loadedNode11.getId());
//
//    }
//
//    @Test
//    public void createDeleteNode() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node0 = db.createNode(root, "node0");
//        TreeDBNode node1 = db.createNode(root, "node1");
//        db.createNode(node1, "node11");
//
//        assertEquals(root.getUUId(), node0.getParent());
//        assertEquals(root.getUUId(), node1.getParent());
//        assertEquals(2, root.sizeChildren());
//        assertEquals(node0.getUUId(), root.findChild("node0").getUUId());
//        assertEquals(node1.getUUId(), root.findChild("node1").getUUId());
//        db.saveAll();
//
//        db.delete(node0);
//
//        assertEquals(1, root.sizeChildren());
//        assertEquals(node1.getUUId(), root.getChild(0).getUUId());
//
//        db.delete(node1);
//        assertEquals(0, root.sizeChildren());
//
//        try {
//            root.getChild(0);
//            fail();
//        } catch (IndexOutOfBoundsException e) {
//
//        } catch (Throwable e) {
//            fail();
//        }
//    }
//
//    @Test
//    public void getFilePath() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node1 = db.createNode(root, "node1");
//        TreeDBNode node2 = db.createNode(root, "node2");
//        TreeDBNode node11 = db.createNode(node1, "node11");
//        TreeDBNode node12 = db.createNode(node1, "node12");
//
//        db.saveAll();
//
//        String pathPrefix = db.getPath() + File.separator
//                + TestNode.type.getName() + File.separator;
//        String pathPostfix = File.separator + TestNode.type.getFileName();
//
//        assertEquals(
//                db.getPath() + File.separator + root.getId() + pathPostfix,
//                db.getNodeFilePath(root));
//
//        assertEquals(pathPrefix + node1.getId() + pathPostfix,
//                db.getNodeFilePath(node1));
//        assertEquals(pathPrefix + node2.getId() + pathPostfix,
//                db.getNodeFilePath(node2));
//        String childPrefix = pathPrefix + node1.getId() + File.separator;
//        assertEquals(childPrefix + node11.getId() + pathPostfix,
//                db.getNodeFilePath(node11));
//        assertEquals(childPrefix + node12.getId() + pathPostfix,
//                db.getNodeFilePath(node12));
//
//        String node11Path = db.getNodeFilePath(node11);
//
//        node1.setId("newNode1");
//        assertEquals(node11Path, db.getNodeFilePath(node11));
//        db.save(node1);
//        assertEquals(
//                pathPrefix + node1.getId() + File.separator + node11.getId()
//                        + pathPostfix, db.getNodeFilePath(node11));
//    }
//
//    @Test
//    public void multitypeRootCreation() {
//        int rootsCount = db.createRootNode(null).sizeChildren();
//
//        TreeDBNode root1 = db.createRootNode(TestNode.type);
//        TreeDBNode root2 = db.createRootNode(AnotherTestNode.type);
//
//        assertEquals(rootsCount + 2, root1.getParentNode().sizeChildren());
//        assertEquals(rootsCount + 2, root2.getParentNode().sizeChildren());
//        db.saveAll();
//
//        TreeDBNode lroot1 = db.getRootNode(TestNode.type, false);
//        TreeDBNode lroot2 = db.getRootNode(AnotherTestNode.type, false);
//
//        assertEquals(rootsCount + 2, lroot1.getParentNode().sizeChildren());
//        assertEquals(rootsCount + 2, lroot2.getParentNode().sizeChildren());
//        assertEquals(root1.getUUId(), lroot1.getUUId());
//        assertEquals(root2.getUUId(), lroot2.getUUId());
//
//    }
//
//    @Test
//    public void moveNode() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node0 = db.createNode(root, "node0");
//        TreeDBNode node1 = db.createNode(root, "node1");
//
//        TreeDBNode child = db.createNode(node0, "node01");
//        assertEquals(node0, child.getParentNode());
//        assertEquals(1, node0.sizeChildren());
//        assertEquals(0, node1.sizeChildren());
//
//        db.move(child, node1);
//        assertEquals(0, node0.sizeChildren());
//        assertEquals(1, node1.sizeChildren());
//        assertEquals(node1, child.getParentNode());
//    }
//
//    @Test
//    public void moveSubnode() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node0 = db.createNode(root, "node0");
//        TreeDBNode node1 = db.createNode(root, "node1");
//        db.createNode(node0, "node01");
//
//        db.move(node0, node1);
//        assertEquals(1, root.sizeChildren());
//        assertEquals(1, node1.sizeChildren());
//        assertEquals(1, node0.sizeChildren());
//
//        // and back
//        db.move(node0, root);
//        assertEquals(2, root.sizeChildren());
//        assertEquals(0, node1.sizeChildren());
//        assertEquals(1, node0.sizeChildren());
//    }
//
//    @Test
//    public void moveComplexNode() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node1 = db.createNode(root, "node1");
//        TreeDBNode node2 = db.createNode(root, "node2");
//        TreeDBNode node3 = db.createNode(root, "node3");
//        db.move(node2, node1);
//        db.move(node1, node3);
//
//        assertEquals(node3, root.findChild(node3.getId()));
//        assertEquals(node1, node3.findChild(node1.getId()));
//        assertEquals(node2, node1.findChild(node2.getId()));
//        assertEquals(0, node2.sizeChildren());
//    }
//
//    @Test
//    public void removeRoot() {
//        assertNull(db.getRootNode(TestNode.type, false));
//        TreeDBNode root = db.getRootNode(TestNode.type, true);
//        assertNotNull(root);
//        db.delete(root);
//        assertNull(db.getRootNode(TestNode.type, false));
//    }
//
//    @Test
//    public void renameTest() {
//        TreeDBNode root = db.createRootNode(TestNode.type);
//        TreeDBNode node = db.createNode(root, "node");
//
//        String pathPrefix = db.getPath() + File.separator
//                + TestNode.type.getName() + File.separator;
//        String pathPostfix = File.separator + TestNode.type.getFileName();
//
//        node.setId("newNode");
//        db.save(node);
//        assertEquals(pathPrefix + node.getId() + pathPostfix, db.getNodeFilePath(node));
//    }
//
//}
