package patterns;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class AddReq {
	@Before
	public static void before() throws Exception {
		// 
		// 
		// 
	}

	@Test
	public static void addReqInExplorer() throws Exception {
		//===    ,  ,   / 
		//===,  ,   OK   Enter.
		//Requirements ->   -> Add Requirement -> ,    01.
		//Requirements ->   -> Add Requirement -> ,    02.
		//   01 ->   -> Add Requirement 
		//-> ,   01   01.
		//   01 ->   -> Remove Requirement -> ,    01.
		//Requirements ->   -> Add Requirement -> ,    03.
		//   03 ->   -> Add Requirement (  01   03)
		//   02 ->   -> Remove Requirement -> OK -> ,    02.
		//   01  03 ->   -> Remove Requirement -> OK 
		//-> ,    01    03.
		//   03 ->   -> Remove Requirement ->  Enter
		//-> ,    03.
		
	}
	
	@Test
	public static void addReqInDoc() throws Exception {
		//Requirements ->   -> Add Requirement
		//   01.
		// .
		
		//===,     .
		//  Requirements. 
		//     ->   -> Create new requirement 02.
		//,    02     Description     .
		//,         .
		
		//===,     .
		//  Requality Explorer   01. 
		//     ->   -> Create new requirement 01.01.
		//,    01   01     Description     .
		//,         .
		
		//===,        .
		//  Requality Explorer   01. 
		//     ->   -> Add to requirement 01.
		//,    01   Description     .
		//,         .
		
		//===,       ,     .
		//  Requality Explorer   02. 
		//     ->   -> Add to requirement 02.
		//,    02  Description         .
		//,         .
		
		//===,        
		//===  Requirement selection.
		//  Requirements. 
		//     ->   -> Add to requirement...
		//,    Requirement selection     (Requirements, 01, 01.01, 02)
		//,   OK  Create new 
		//  02 
		//,   Create new  OK 
		//  OK
		//,    02  Description         .
		//,         .
		
		//===,      
		//===   Requirement selection.
		//  Requirements. 
		//     ->   -> Add to requirement...
		//  02 -> Create new
		//,    Identifier editor
		// 02 -> OK
		//,    Requirement selection   02   
		//OK
		//,    02   02     Description     .
		//,         .
		
		//Look
		//   02  02. ->  Look
		//,      ,    .
		
		//===,      
		//===   Requirement selection   Description.
		//  Requirements. 
		//     ->   -> Add to requirement...
		//  02 -> Create new
		// 01 -> OK
		//,    Requirement selection   01   
		//Cancel
		//,    01   02     Description
		//,           .

	}
	
	@Test
	public static void addReqWithExistedId() throws Exception {
		//Requirements ->   -> Add Requirement
		//   01.
		// .
		
		//===,        .
		//     ->   -> Add to requirement...
		// Requirements -> Create new
		// 01 -> OK
		//,           id.
		// OK -> Cancel.
		//,    Requirements     01.
	}
	
	@Test
	public static void editReqIdAndName() throws Exception {
		//Requirements ->   -> Add Requirement
		//   01.
		// .
		
		//=== id
		//   01 ->  Requirements identifier  011 ->  
		//->,  id     011.
		//->,      011.
		//->,    Name   011 (  ).
		//->,   Requality Explorer      011.
		
		//=== name
		//   011 ->   Name
		//->,   Name  .
		// Name  02 -> 
		//->   :
		//id  - 011.
		//Name - 02  .
		//  - 02.
		//->,   Requality Explorer     02.
		
		//===  Name
		//     02 ->   Name
		//->,   Name  .
		//-> 
		//->   :
		//id  - 011.
		//Name - 011  .
		//  - 011.
		//->,   Requality Explorer     011.
		
		//=== id   name
		//   011 ->   Name -> 
		// id  03 -> 
		//->   :
		//id  - 03.
		//Name - 011  .
		//  - 011.
		//->,   Requality Explorer    011.
		
		//=== name,     
		//   011 ->   Name -> 
		// id  name - 011
		//    Requirements Explorer.
		//->,      012.
		// name  012  011   .
		//->,   .
		//->, :
		//id   011  012.
		//Name    - 011.
		//     - 011.
		//->,   Requality Explorer     011.
		
		//===ID    2    id   .
		//    Requirements Explorer.
		//->,      013.
		
		//=== id,     
		// id  013  011   .
		//,    .
		// id  013  012   .
		//,    .	
		
	}
	
	@Test
	public static void editReqAlternativeDescription() throws Exception {
		//Requirements ->   -> Add Requirement
		//   01.
		// .
		
		// Alternative Description
		//       ->   -> ,   .
	}
	
	@Test
	public static void editReqAttribute() throws Exception {
		//Requirements ->   -> Add Requirement
		//   01.
		// .
		
		//   
		// Add ->    w   22. -> Cancel
		//-> ,    .
		// Add ->    w   22. -> OK
		//-> ,   .
		//  -> ,   .
		
		//     
		// Add ->    b,   . -> OK
		//-> ,   b   .
		
		//     
		// Add ->    22,   . -> OK
		//-> ,         .
		//-> OK -> ,           .
		
		//      
		// Add ->      . -> OK
		//-> ,           .
		//-> OK -> ,         -  .
		
		// 
		//      w
		//->    ,    33. -> OK
		//-> ,   w ,       33.
		
		//     
		//      b
		//->    . -> OK
		//-> ,     ,       . -> OK
		//-> ,    b       .
		
		//     .
		// Add ->     -> OK
		//-> ,     ,       . -> OK
		//-> ,           .
		
		// .
		//  b ->  Remove
		//-> ,        . -> Yes
		//-> ,   b .
		//   ->  Remove
		//-> ,        . -> No
		//-> ,     .

	}
	
	@Test
	public static void editReqPredicate() throws Exception {
		//Requirements ->   -> Add Requirement
		//   01.
		// .
		
		// 
		//       ->   -> ,   .
	}
			
	@After
	public static void sleep() throws Exception {
		
	}
}
